#define _BSD
#include <sys/param.h>
#include <sys/wait.h>
#include <errno.h>
typedef struct mail_handle{
  int pid;
  int in[2];
} *mail_handle;

void write_mail(mail_handle m,void *buffer,int length)
{
  write (m->in[1],buffer,length);
}

void *open_mail(char *mailer,char *destination)
{
  mail_handle m=(mail_handle)malloc(sizeof(struct mail_handle));

  pipe(m->in);
  if (!(m->pid=vfork())){
    close(0);
    dup2(m->in[0],0);
    execlp(mailer,mailer/*"-I","-s","automail"*/,destination,0);
    close(m->in[1]);
    close(m->in[0]);
    close(1);
    perror ("mailer exec error");
    exit(0);
  }
  return(m);
}

void close_mail(mail_handle m)
{
  int omask,pid;
  union wait pstat;
  int status;

  write(m->in[1],"\012.\012",3);
  write(m->in[1],"\012\004\012",3);
  close(m->in[1]);
  close(m->in[0]);
  
  /* Get the status of the process. */
  omask = sigblock(sigmask(SIGINT)|sigmask(SIGQUIT)|sigmask(SIGHUP));
  do {
    pid = waitpid(m->pid, (int *) &pstat, 0);
  } while (pid == -1 && errno == EINTR);
  (void)sigsetmask(omask);
  free(m);
}
