#include <ppa.h>

ppa create_ppa(int degree) /* degree now == b*/
{
  ppa p=(ppa)malloc(sizeof(struct ppa));
  unsigned int i;
  p->degree=degree;
  p->markers=(float *)malloc(sizeof (float)*(degree+2));
  p->positions=( int *)malloc(sizeof (int)*(degree+2));
  p->sample_count=0;
  for (i=1;i<degree+2;i++) p->positions[i]=i;
  return(p);
}

void add_sample(ppa p,float sample)
{
  unsigned i,k;
  float w,d,q;
  int di;
  if (p->sample_count < p->degree+2){
    for (i=1;i<=p->sample_count;i++)
      if (sample < p->markers[i]){
	w=p->markers[i];
	p->markers[i]=sample;
	sample=w;
      }
    p->markers[i]=sample;
  } else {
    if (sample < p->markers[0]){
      p->markers[k=1]=sample;
    } else {
      if (sample > p->markers[p->degree+1]){
	p->markers[p->degree+1]=sample;
	k=p->degree;
      } else {
	for (k=1;sample>p->markers[k];k++);
	k--;
      }
    }
    for (i=k+1;i<=p->degree+1;i++) p->positions[i]++;

    for (i=2;i<=(p->degree);i++){
      d=(1.0+(i-1.0)*((float)p->positions[p->degree+1]-1.0)/((float)p->degree))
	-(float)p->positions[i];
      if (((d>=1.0) && ((p->positions[i+1]-p->positions[i])>1)) ||
	  ((d<=-1.0) && ((p->positions[i-1]-p->positions[i])<-1))){
	di=d>0.0?1.0:-1.0;
	q= p->markers[i]+(float)di/
	  (float)(p->positions[i+1]-p->positions[i-1])*
	  (((p->positions[i]-p->positions[i-1]+(float)di)*
	    (p->markers[i+1]-p->markers[i])/
	    (p->positions[i+1]-p->positions[i]))
	   +
	   ((p->positions[i+1]-p->positions[i]-(float)di)*
	    (p->markers[i]-p->markers[i-1])/
	    (p->positions[i]-p->positions[i-1])));
	
	if ((q > p->markers[i-1]) && (q < p->markers[i+1])){
	  p->markers[i]=q;
	} else {
	  p->markers[i]=p->markers[i]+di*
	    ((p->markers[i+di]-p->markers[i])/
	     (p->positions[i+di]-p->positions[i]));
	  
	}
	p->positions[i]+=di;
      }
    }
  }
  p->sample_count++;
}

void destroy_ppa(ppa a)
{
  free(a->markers);
  free(a->positions);
  free(a);
}
